"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.generate = exports.beforeCompile = exports.serverConf = exports.dllConf = exports.clientConf = exports.options = void 0;
var babelrc = _interopRequireWildcard(require("./babelrc"));function _getRequireWildcardCache() {if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function () {return cache;};return cache;}function _interopRequireWildcard(obj) {if (obj && obj.__esModule) {return obj;}if (obj === null || typeof obj !== "object" && typeof obj !== "function") {return { default: obj };}var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {return cache.get(obj);}var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {if (Object.prototype.hasOwnProperty.call(obj, key)) {var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {Object.defineProperty(newObj, key, desc);} else {newObj[key] = obj[key];}}}newObj.default = obj;if (cache) {cache.set(obj, newObj);}return newObj;}

/**
* babel7 loader配置
*
* @param {*} chainedConfig  webpack 配置
* @param {*} rulename rule 的名称
* @param {*} option babel选项
*/
const babelLoader = (chainedConfig, rulename = 'js-compile', option) => {
  chainedConfig.module.rule(rulename).
  use('babel-loader').
  loader(require.resolve('babel-loader')).
  options(option);
};

const options = joi => ({
  pluginScheme: {
    babelrc: joi.object({
      include: joi.array(),
      plugins: joi.alternatives(
      joi.array(),
      joi.string()),

      presets: joi.alternatives(
      joi.array(),
      joi.string()) }),


    dll: joi.object({
      chunks: joi.object() }) },


  pluginDefaultOptions: {
    /**
             * {
             *    presets: {Array<string> | string}
             *    plugins: {Array<string> | string}
             *  }
             */
    babelrc: {
      // include:[],
      // 可以使用以下配置尝试新功能
      // plugins:[
      //     "@babel/plugin-proposal-class-properties",
      //     ["@babel/plugin-proposal-decorators", {legacy: true}],
      //     "@babel/plugin-proposal-do-expressions",
      //     "@babel/plugin-proposal-export-default-from",
      //     "@babel/plugin-proposal-export-namespace-from",
      //     "@babel/plugin-proposal-function-bind",
      //     "@babel/plugin-proposal-function-sent",
      //     "@babel/plugin-proposal-json-strings",
      //     "@babel/plugin-proposal-logical-assignment-operators",
      //     "@babel/plugin-proposal-nullish-coalescing-operator",
      //     "@babel/plugin-proposal-numeric-separator",
      //     "@babel/plugin-proposal-optional-chaining",
      //     ["@babel/plugin-proposal-pipeline-operator", { "proposal": "minimal" }],
      //     "@babel/plugin-proposal-throw-expressions",
      // ]
    },
    dll: {
      chunks: {} } } });exports.options = options;




const clientConf = (chainedConfig, env, config) => {
  babelLoader(chainedConfig, 'js-compile', babelrc.clientOptions(config, env === 'DEBUG'));
};exports.clientConf = clientConf;

const dllConf = (chainedConfig, env, config) => {
  babelLoader(chainedConfig, 'js-compile', babelrc.dllOptions(config));
};exports.dllConf = dllConf;

const serverConf = (chainedConfig, env, config) => {
  babelLoader(chainedConfig, 'js-compile', babelrc.serverOptions(config));

  if (env !== 'DEBUG') {
    babelLoader(chainedConfig, 'insertHtmlTemplate', babelrc.serverOptions(config));
  }
};exports.serverConf = serverConf;

const beforeCompile = (env, config, options) => {
  babelrc.update(config, env === 'DEBUG');
};exports.beforeCompile = beforeCompile;

const generate = options => ({
  dependencies: {
    'core-js': '^3.6.4',
    '@babel/runtime-corejs3': '^7.8.4' },

  devDependencies: {
    '@babel/core': '^7.8.4' } });exports.generate = generate;